package metaedit.style;

import java.awt.Color;

import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

public class Focuser extends EditorStyle {
	protected SimpleAttributeSet focusCleaner = new SimpleAttributeSet();

	private int offset = -1;

	private int length = -1;
	
	public Focuser() {
		setBackgroundColor(Color.BLUE);
		setForegroundColor(Color.WHITE);
	}

	public void setFocus(StyledDocument document, int offset, int length) {
		this.setStyle(document, offset, length);
		this.offset = offset;
		this.length = length;
	}

	public void clearFocus(StyledDocument document, Color bgColor) {
		if (offset >= 0 && length >= 0) {
			StyleConstants.setBackground(focusCleaner, bgColor);
			document.setCharacterAttributes(offset, length, focusCleaner, false);
		}
	}

	public SimpleAttributeSet getFocusCleaner() {
		return focusCleaner;
	}

	public int getLengthTemp() {
		return length;
	}

	public int getOffsetTemp() {
		return offset;
	}

	public void setLengthTemp(int i) {
		length = i;
	}

	public void setOffsetTemp(int i) {
		offset = i;
	}

}